{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, System.ComponentModel, Borland.Vcl.StdCtrls, Unit2;


type
  [TCodeRevision('Olivier','24-3-06',Relu=True)]
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation



{$R *.nfm}



procedure TForm1.Button1Click(Sender: TObject);
var T:System.Type;
    A:array of TObject;
    I:integer;
begin
 T := Self.GetType;
 A := T.GetCustomAttributes(true);
 Memo1.Clear;
 memo1.Lines.Append('Type: '+T.FullName);
 for i:=low(A) to high(A) do
  memo1.Lines.Append(A[i].GetType.FullName);
end;

procedure TForm1.Button2Click(Sender: TObject);
var T :System.Type;
    A : array of TObject;
    CR:TCodeRevision;
begin
 T := Self.GetType;
 A := T.GetCustomAttributes(TypeOf(TCodeRevision),false);
 if high(A)=-1 then CR:=nil else CR := TCodeRevision(A[0]);
 memo1.clear;
 if not assigned(cr) then begin
  memo1.Lines.Append('Attribut non support');
  exit;
  end;
 With memo1.Lines do begin
  Append('Auteur  : '+CR.Auteur);
  Append('Date    : '+CR.Date);
  Append('Relu    : '+Booltostr(CR.Relu,true));
  Append('Version : '+Inttostr(CR.Version));
  end;
end;

end.
