{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, System.ComponentModel, Borland.Vcl.StdCtrls,
  Borland.Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    btnGo: TButton;
    btnClear: TButton;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure btnGoClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure EventHandler1(sender:tobject);
    procedure EventHandler2(sender:tobject);
  end;

var
  Form1: TForm1;

implementation

{$R *.nfm}

type
 TMulticastDemo = class
  private
   fevent : tnotifyevent;
  public
   procedure DoEvent;
   property event : tnotifyevent add fevent remove fevent;
  end;

  procedure TMulticastDemo.DoEvent;
  begin
   Form1.Shape1.Brush.Color := clred;
   if assigned(fevent) then fevent(self);
  end;

procedure TForm1.EventHandler1(sender:tobject);
begin
 shape2.Brush.Color := clred;
end;

procedure TForm1.EventHandler2(sender:tobject);
begin
 shape3.Brush.Color := clred;
end;

procedure TForm1.btnGoClick(Sender: TObject);
var M:TMulticastDemo;
begin
 M := TMulticastDemo.Create;
 Include(M.event,EventHandler1);
 Include(M.event,EventHandler2);
 M.DoEvent;
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
 Shape1.Brush.Color := clwhite;
 Shape2.Brush.Color := clwhite;
 Shape3.Brush.Color := clwhite;
end;


end.
